"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createModule = void 0;
var toolkit_1 = require("@reduxjs/toolkit");
var redux_observable_1 = require("redux-observable");
var createModule = function (_a) {
    var name = _a.name, _b = _a.initialState, initialState = _b === void 0 ? {} : _b, reducers = _a.reducers, selectors = _a.selectors, epics = _a.epics, extraReducers = _a.extraReducers;
    var _initialState = {};
    if (initialState) {
        if (typeof initialState === 'function') {
            _initialState = initialState(_initialState);
        }
        else {
            _initialState = __assign(__assign({}, _initialState), initialState);
        }
    }
    var _selectors = {};
    if (selectors) {
        if (typeof selectors === 'function') {
            _selectors = selectors(_selectors);
        }
        else {
            _selectors = __assign(__assign({}, _selectors), selectors);
        }
    }
    var _reducers = {};
    if (reducers) {
        if (typeof reducers === 'function') {
            _reducers = reducers(_reducers);
        }
        else {
            _reducers = __assign(__assign({}, _reducers), reducers);
        }
    }
    var fixedReducers = Object.keys(_reducers).reduce(function (_fixedReducers, reducerName) {
        var _a;
        var ro = _reducers[reducerName];
        if (typeof ro === 'function') {
            ro = {
                reducer: ro,
                prepare: function (arg) {
                    if (arg === void 0) { arg = {}; }
                    if (Array.isArray(arg)) {
                        return { payload: arg };
                    }
                    else if (typeof arg === 'object') {
                        var meta = arg.meta, error = arg.error, payload = __rest(arg, ["meta", "error"]);
                        return { payload: payload, meta: meta, error: error };
                    }
                    else {
                        return { payload: arg };
                    }
                },
            };
        }
        return __assign(__assign({}, _fixedReducers), (_a = {}, _a[reducerName] = ro, _a));
    }, {});
    var slice = (0, toolkit_1.createSlice)({
        name: name,
        initialState: _initialState,
        reducers: fixedReducers,
        extraReducers: extraReducers,
    });
    var _epics = {};
    if (epics) {
        if (typeof epics === 'function') {
            _epics = epics(_epics);
        }
        else {
            _epics = __assign(__assign({}, _epics), epics);
        }
    }
    var epicList = Object.keys(_epics).map(function (k) { return _epics[k]; });
    var epic = redux_observable_1.combineEpics.apply(void 0, epicList);
    return {
        slice: slice,
        epic: epic,
        name: name,
        actions: slice.actions,
        reducer: slice.reducer,
        selectors: _selectors,
    };
};
exports.createModule = createModule;
