"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
var __rest = (this && this.__rest) || function (s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.createModule = void 0;
var toolkit_1 = require("@reduxjs/toolkit");
var operators_1 = require("rxjs/operators");
var rxjs_1 = require("rxjs");
var redux_observable_1 = require("redux-observable");
var state_1 = require("../utils/state");
var createModule = function (_a) {
    var name = _a.name, resourceUrl = _a.resourceUrl, resourceType = _a.resourceType, _b = _a.initialState, initialState = _b === void 0 ? {} : _b, reducers = _a.reducers, selectors = _a.selectors, epics = _a.epics, _c = _a.ajaxThrottleTime, ajaxThrottleTime = _c === void 0 ? 1000 : _c, extraReducers = _a.extraReducers;
    var _initialState = {
        listData: [],
        total: 0,
        current: 1,
        pageSize: 10,
        selectedData: [],
        searchData: {},
        orderby: '',
        syncing: false,
        syncingItems: {},
        creating: false,
        updatingItems: {},
        removingItems: [],
        syncingAll: false,
        dataMap: {},
        moduleParams: {},
    };
    if (initialState) {
        if (typeof initialState === 'function') {
            _initialState = initialState(_initialState);
        }
        else {
            _initialState = __assign(__assign({}, _initialState), initialState);
        }
    }
    var _selectors = {
        selectModule: function (state) { return (0, state_1.getState)(state, [name], _initialState); },
        selectModuleParams: function (state) { return (0, state_1.getState)(state, [name, 'moduleParams'], {}); },
        selectPagination: function (state) { return ({
            current: (0, state_1.getState)(state, [name, 'current'], 1),
            pageSize: (0, state_1.getState)(state, [name, 'pageSize'], 10),
            total: (0, state_1.getState)(state, [name, 'total'], 0),
        }); },
        selectPageData: function (state) {
            return (0, state_1.getStateIn)(state, [name, 'listData'], function (list) {
                return list
                    .map(function (id) { return (0, state_1.getState)(state, [name, 'dataMap', id]); })
                    .filter(Boolean);
            });
        },
        selectSelected: function (state) { return (0, state_1.getState)(state, [name, 'selectedData'], []); },
        selectSelectedData: function (state) {
            return (0, state_1.getStateIn)(state, [name, 'selectedData'], function (ids) {
                return ids.map(function (id) { return (0, state_1.getState)(state, [name, 'dataMap', id]); }).filter(Boolean);
            }, []);
        },
        selectSearchData: function (state) { return (0, state_1.getState)(state, [name, 'searchData'], {}); },
        selectOrderby: function (state) { return (0, state_1.getState)(state, [name, 'orderby'], ''); },
        selectSyncing: function (state) { return (0, state_1.getState)(state, [name, 'syncing'], false); },
        selectItemSyncing: function (id) { return function (state) {
            return (0, state_1.getState)(state, [name, 'syncingItems', id], false);
        }; },
        selectCreating: function (state) { return (0, state_1.getState)(state, [name, 'creating'], false); },
        selectItemUpdating: function (id) { return function (state) {
            return (0, state_1.getState)(state, [name, 'updatingItems', id], false);
        }; },
        selectItemRemoving: function (id) { return function (state) {
            return (0, state_1.getStateIn)(state, [name, 'removingItems'], function (ids) { return ids.includes(id); }, false);
        }; },
        selectAllSyncing: function (state) { return (0, state_1.getState)(state, [name, 'syncingAll'], false); },
        selectItemSyncStatus: function (id) {
            return function (state) {
                return {
                    reading: (0, state_1.getState)(state, [name, 'syncingItems', id], false),
                    updating: (0, state_1.getState)(state, [name, 'updatingItems', id], false),
                    removing: (0, state_1.getStateIn)(state, [name, 'removingItems'], function (ids) { return ids.includes(id); }, false),
                };
            };
        },
        selectAllData: function (state) { return (0, state_1.getState)(state, [name, 'dataMap'], {}); },
        selectAllDataList: function (state) {
            return (0, state_1.getStateIn)(state, [name, 'dataMap'], function (dm) {
                return Object.keys(dm).map(function (id) { return dm[id]; });
            }, []);
        },
        selectAllDataOptions: function (state) {
            return (0, state_1.getStateIn)(state, [name, 'dataMap'], function (dm) {
                return Object.keys(dm).map(function (d) { return ({
                    name: (0, state_1.getState)(dm, [d, 'name']),
                    value: d,
                }); });
            });
        },
        selectOneItem: function (id) { return function (state) { return (0, state_1.getState)(state, [name, 'dataMap', id], {}); }; },
        selectItemByIDList: function (idList) { return function (state) {
            return (0, state_1.getStateIn)(state, [name, 'dataMap'], function (dm) {
                return idList.map(function (id) { return (0, state_1.getState)(dm, [id], {}); });
            }, []);
        }; },
    };
    if (selectors) {
        if (typeof selectors === 'function') {
            _selectors = selectors(_selectors);
        }
        else {
            _selectors = __assign(__assign({}, _selectors), selectors);
        }
    }
    var _reducers = {
        updateModuleParams: function (state, action) {
            return (0, state_1.updateState)(state, ['moduleParams'], action.payload);
        },
        updateCurrent: function (state, action) { return (0, state_1.updateState)(state, ['current'], action.payload); },
        updatePageSize: function (state, action) { return (0, state_1.updateState)(state, ['pageSize'], action.payload); },
        updateSelectedData: function (state, action) {
            return (0, state_1.updateState)(state, ['selectedData'], action.payload);
        },
        updateSearch: function (state, action) { return (0, state_1.updateState)(state, ['searchData'], action.payload); },
        updateOrderBy: function (state, action) { return (0, state_1.updateState)(state, ['orderby'], action.payload); },
        sync: function (state, action) { return state; },
        syncStarted: function (state, action) { return (0, state_1.updateState)(state, ['syncing'], true); },
        syncEnded: function (state, action) { return (0, state_1.updateState)(state, ['syncing'], false); },
        syncFulfilled: function (state, _a) {
            var _b = _a.payload, data = _b.data, count = _b.count;
            state = (0, state_1.updateState)(state, ['listData'], data.map(function (d) { return d.id; }));
            state = (0, state_1.updateStateIn)(state, ['selectedData'], function (idList) {
                return idList.filter(function (id) { return (0, state_1.getState)(state, ['listData'], []).includes(id); });
            });
            state = (0, state_1.updateState)(state, ['total'], count);
            state = (0, state_1.updateStateIn)(state, ['dataMap'], function (dm) {
                return data.reduce(function (suc, i) {
                    var _a;
                    return (__assign(__assign({}, suc), (_a = {}, _a[i.id] = i, _a)));
                }, dm);
            });
            return state;
        },
        syncRejected: function (state, action) { return state; },
        cancelSync: function (state, action) { return state; },
        syncItem: function (state, action) { return state; },
        syncItemStarted: function (state, _a) {
            var id = _a.payload.id;
            return (0, state_1.updateState)(state, ['syncingItems', id], true);
        },
        syncItemEnded: function (state, _a) {
            var id = _a.payload.id;
            return (0, state_1.updateState)(state, ['syncingItems', id], false);
        },
        syncItemFulfilled: function (state, _a) {
            var _b = _a.payload, id = _b.id, data = _b.data;
            return (0, state_1.updateState)(state, ['dataMap', id], data);
        },
        syncItemRejected: function (state, action) { return state; },
        cancelSyncItem: function (state, action) { return state; },
        createItem: function (state, action) { return state; },
        createItemStarted: function (state, action) { return (0, state_1.updateState)(state, ['creating'], true); },
        createItemEnded: function (state, action) { return (0, state_1.updateState)(state, ['creating'], false); },
        createItemFulfilled: function (state, _a) {
            var data = _a.payload.data;
            return (0, state_1.updateState)(state, ['dataMap', data.id], data);
        },
        createItemRejected: function (state, action) { return state; },
        cancelCreateItem: function (state, action) { return state; },
        updateItem: function (state, action) { return state; },
        updateItemStarted: function (state, _a) {
            var id = _a.payload.id;
            return (0, state_1.updateState)(state, ['updatingItems', id], true);
        },
        updateItemEnded: function (state, _a) {
            var id = _a.payload.id;
            return (0, state_1.updateState)(state, ['updatingItems', id], false);
        },
        updateItemFulfilled: function (state, _a) {
            var _b = _a.payload, id = _b.id, data = _b.data;
            return (0, state_1.updateState)(state, ['dataMap', id], data);
        },
        updateItemRejected: function (state, action) { return state; },
        cancelUpdateItem: function (state, action) { return state; },
        update: function (state, action) { return state; },
        updateStarted: function (state, _a) {
            var data = _a.payload.data;
            return (0, state_1.updateStateIn)(state, ['updatingItems'], function (sts) {
                return data.reduce(function (s, d) { return (0, state_1.updateState)(s, [d.id], true); }, sts);
            });
        },
        updateEnded: function (state, _a) {
            var data = _a.payload.data;
            return (0, state_1.updateStateIn)(state, ['updatingItems'], function (sts) {
                return data.reduce(function (s, d) { return (0, state_1.updateState)(s, [d.id], false); }, sts);
            });
        },
        updateFulfilled: function (state, _a) {
            var data = _a.payload.data;
            return (0, state_1.updateStateIn)(state, ['dataMap'], function (dm) {
                return data.reduce(function (dms, d) { return (0, state_1.updateState)(dms, [d.id], d); }, dm);
            });
        },
        updateRejected: function (state, action) { return state; },
        cancelUpdate: function (state, action) { return state; },
        remove: function (state, action) { return state; },
        removeStarted: function (state, _a) {
            var ids = _a.payload.ids;
            return (0, state_1.updateState)(state, ['removingItems'], ids);
        },
        removeEnded: function (state, _a) {
            var ids = _a.payload.ids;
            return (0, state_1.updateState)(state, ['removingItems'], []);
        },
        removeFulfilled: function (state, _a) {
            var ids = _a.payload.ids;
            state = (0, state_1.updateStateIn)(state, ['listData'], function (idList) {
                return idList.filter(function (id) { return !ids.includes(id); });
            });
            state = (0, state_1.updateStateIn)(state, ['selectedData'], function (idList) {
                return idList.filter(function (id) { return !ids.includes(id); });
            });
            state = (0, state_1.updateStateIn)(state, ['total'], function (total) { return total - ids.length; });
            return ids.reduce(function (sts, id) { return (0, state_1.removeState)(sts, ['dataMap', id]); }, state);
        },
        removeRejected: function (state, action) { return state; },
        cancelRemove: function (state, action) { return state; },
        syncAll: function (state, action) { return state; },
        syncAllStarted: function (state, action) { return (0, state_1.updateState)(state, ['syncingAll'], true); },
        syncAllEnded: function (state, action) { return (0, state_1.updateState)(state, ['syncingAll'], false); },
        syncAllFulfilled: function (state, _a) {
            var data = _a.payload.data;
            return (0, state_1.updateStateIn)(state, ['dataMap'], function (dm) {
                return data.reduce(function (dmNext, d) {
                    return (0, state_1.updateState)(dmNext, [d.id], d);
                }, dm);
            });
        },
        syncAllRejected: function (state, action) { return state; },
        cancelSyncAll: function (state, action) { return state; },
    };
    if (reducers) {
        if (typeof reducers === 'function') {
            _reducers = reducers(_reducers);
        }
        else {
            _reducers = __assign(__assign({}, _reducers), reducers);
        }
    }
    var fixedReducers = Object.keys(_reducers).reduce(function (_fixedReducers, reducerName) {
        var _a;
        var ro = _reducers[reducerName];
        if (typeof ro === 'function') {
            ro = {
                reducer: ro,
                prepare: function (arg) {
                    if (arg === void 0) { arg = {}; }
                    if (Array.isArray(arg)) {
                        return { payload: arg };
                    }
                    else if (typeof arg === 'object') {
                        var meta = arg.meta, error = arg.error, payload = __rest(arg, ["meta", "error"]);
                        return { payload: payload, meta: meta, error: error };
                    }
                    else {
                        return { payload: arg };
                    }
                },
            };
        }
        return __assign(__assign({}, _fixedReducers), (_a = {}, _a[reducerName] = ro, _a));
    }, {});
    var slice = (0, toolkit_1.createSlice)({
        name: name,
        initialState: _initialState,
        reducers: fixedReducers,
        extraReducers: extraReducers,
    });
    // epics
    var syncEpic = function (action$, state$, _a) {
        var get = _a.get;
        return action$.pipe((0, operators_1.filter)(slice.actions.sync.match), (0, operators_1.throttleTime)(ajaxThrottleTime), (0, operators_1.mergeMap)(function (_a) {
            var payload = _a.payload, meta = _a.meta;
            var _b = state$.value[name], searchData = _b.searchData, moduleParams = _b.moduleParams;
            return get(resourceUrl, __assign(__assign(__assign(__assign({}, searchData), { resource_type: resourceType }), moduleParams), { _onlycount: 1 })).pipe((0, operators_1.mergeMap)(function (ar) {
                var count = ar.response;
                var _a = state$.value[name], current = _a.current, pageSize = _a.pageSize, orderby = _a.orderby;
                return (0, rxjs_1.combineLatest)([
                    (0, rxjs_1.of)(count),
                    get(resourceUrl, __assign(__assign(__assign(__assign({}, searchData), { resource_type: resourceType }), moduleParams), { limit: pageSize, offset: pageSize * (current - 1), orderby: orderby })),
                ]);
            }), (0, operators_1.map)(function (_a) {
                var _b;
                var count = _a[0], arn = _a[1];
                var response = arn.response;
                (_b = meta === null || meta === void 0 ? void 0 : meta.done) === null || _b === void 0 ? void 0 : _b.call(meta, arn);
                return slice.actions.syncFulfilled({ count: count, data: response });
            }), (0, operators_1.startWith)(slice.actions.syncStarted({})), (0, operators_1.takeUntil)(action$.pipe((0, operators_1.filter)(slice.actions.cancelSync.match))), (0, rxjs_1.catchError)(function (err) {
                var _a;
                (_a = meta === null || meta === void 0 ? void 0 : meta.fail) === null || _a === void 0 ? void 0 : _a.call(meta, err);
                return (0, rxjs_1.of)(slice.actions.syncRejected({ error: err }));
            }), (0, operators_1.endWith)(slice.actions.syncEnded({})));
        }));
    };
    var syncItemEpic = function (action$, state$, _a) {
        var get = _a.get;
        return action$.pipe((0, operators_1.filter)(slice.actions.syncItem.match), (0, operators_1.mergeMap)(function (_a) {
            var id = _a.payload.id, meta = _a.meta;
            return get(resourceUrl, { resource_type: resourceType, id: id }).pipe((0, operators_1.map)(function (ar) {
                var _a;
                var response = ar.response;
                (_a = meta === null || meta === void 0 ? void 0 : meta.done) === null || _a === void 0 ? void 0 : _a.call(meta, ar);
                return slice.actions.syncItemFulfilled({ id: id, data: response[0] });
            }), (0, operators_1.startWith)(slice.actions.syncItemStarted({ id: id })), (0, operators_1.takeUntil)(action$.pipe((0, operators_1.filter)(function (_a) {
                var type = _a.type, payload = _a.payload;
                return type === slice.actions.cancelSyncItem.type && (payload === null || payload === void 0 ? void 0 : payload.id) === id;
            }))), (0, rxjs_1.catchError)(function (err) {
                var _a;
                (_a = meta === null || meta === void 0 ? void 0 : meta.fail) === null || _a === void 0 ? void 0 : _a.call(meta, err);
                return (0, rxjs_1.of)(slice.actions.syncItemRejected({ error: err, id: id }));
            }), (0, operators_1.endWith)(slice.actions.syncItemEnded({ id: id })));
        }));
    };
    var createItemEpic = function (action$, state$, _a) {
        var post = _a.post;
        return action$.pipe((0, operators_1.filter)(slice.actions.createItem.match), (0, operators_1.throttleTime)(ajaxThrottleTime), (0, operators_1.mergeMap)(function (_a) {
            var data = _a.payload.data, meta = _a.meta;
            return post(resourceUrl, {
                resource_type: resourceType,
                attrs: [data],
            }).pipe((0, operators_1.map)(function (ar) {
                var _a;
                var response = ar.response;
                (_a = meta === null || meta === void 0 ? void 0 : meta.done) === null || _a === void 0 ? void 0 : _a.call(meta, ar);
                return slice.actions.createItemFulfilled({ data: response[0] });
            }), (0, operators_1.startWith)(slice.actions.createItemStarted({})), (0, operators_1.takeUntil)(action$.pipe((0, operators_1.filter)(slice.actions.cancelCreateItem.match))), (0, rxjs_1.catchError)(function (err) {
                var _a;
                (_a = meta === null || meta === void 0 ? void 0 : meta.fail) === null || _a === void 0 ? void 0 : _a.call(meta, err);
                return (0, rxjs_1.of)(slice.actions.createItemRejected({ data: data, error: err }));
            }), (0, operators_1.endWith)(slice.actions.createItemEnded({})));
        }));
    };
    var updateItemEpic = function (action$, state$, _a) {
        var put = _a.put;
        return action$.pipe((0, operators_1.filter)(slice.actions.updateItem.match), (0, operators_1.throttleTime)(ajaxThrottleTime), (0, operators_1.mergeMap)(function (_a) {
            var _b = _a.payload, id = _b.id, data = _b.data, meta = _a.meta;
            var storeData = (0, state_1.getState)(state$.value, [slice.name, 'dataMap', id], {});
            return put(resourceUrl, {
                resource_type: resourceType,
                attrs: [__assign(__assign(__assign({}, storeData), data), { id: id })],
            }).pipe((0, operators_1.map)(function (ar) {
                var _a;
                var response = ar.response;
                (_a = meta === null || meta === void 0 ? void 0 : meta.done) === null || _a === void 0 ? void 0 : _a.call(meta, ar);
                return slice.actions.updateItemFulfilled({ data: response[0], id: id });
            }), (0, operators_1.startWith)(slice.actions.updateItemStarted({ id: id })), (0, operators_1.takeUntil)(action$.pipe((0, operators_1.filter)(function (_a) {
                var type = _a.type, payload = _a.payload;
                return type === slice.actions.cancelUpdateItem.type && (payload === null || payload === void 0 ? void 0 : payload.id) === id;
            }))), (0, rxjs_1.catchError)(function (err) {
                var _a;
                (_a = meta === null || meta === void 0 ? void 0 : meta.fail) === null || _a === void 0 ? void 0 : _a.call(meta, { error: err, id: id, data: data });
                return (0, rxjs_1.of)(slice.actions.updateItemRejected({ id: id, data: data, error: err }));
            }), (0, operators_1.endWith)(slice.actions.updateItemEnded({ id: id })));
        }));
    };
    var updateEpic = function (action$, state$, _a) {
        var put = _a.put;
        return action$.pipe((0, operators_1.filter)(slice.actions.update.match), (0, operators_1.throttleTime)(ajaxThrottleTime), (0, operators_1.mergeMap)(function (_a) {
            var data = _a.payload.data, meta = _a.meta;
            var storeData = (0, state_1.getStateIn)(state$.value, [slice.name, 'dataMap'], function (dm) {
                return data.map(function (d) { return (__assign(__assign({}, dm[d.id]), d)); });
            });
            return put(resourceUrl, {
                resource_type: resourceType,
                attrs: __spreadArray([], storeData, true),
            }).pipe((0, operators_1.map)(function (ar) {
                var _a;
                var response = ar.response;
                (_a = meta === null || meta === void 0 ? void 0 : meta.done) === null || _a === void 0 ? void 0 : _a.call(meta, ar);
                return slice.actions.updateFulfilled({ data: response });
            }), (0, operators_1.startWith)(slice.actions.updateStarted({ data: data })), (0, operators_1.takeUntil)(action$.pipe((0, operators_1.filter)(slice.actions.cancelUpdate.match))), (0, rxjs_1.catchError)(function (err) {
                var _a;
                (_a = meta === null || meta === void 0 ? void 0 : meta.fail) === null || _a === void 0 ? void 0 : _a.call(meta, err);
                return (0, rxjs_1.of)(slice.actions.updateRejected({ data: data, error: err }));
            }), (0, operators_1.endWith)(slice.actions.updateEnded({ data: data })));
        }));
    };
    var removeEpic = function (action$, state$, _a) {
        var del = _a.del;
        return action$.pipe((0, operators_1.filter)(slice.actions.remove.match), (0, operators_1.throttleTime)(ajaxThrottleTime), (0, operators_1.mergeMap)(function (_a) {
            var ids = _a.payload.ids, meta = _a.meta;
            var attrs = ids.map(function (id) { return ({ id: id }); });
            return del(resourceUrl, { resource_type: resourceType, attrs: attrs }).pipe((0, operators_1.map)(function (ar) {
                var _a;
                var response = ar.response;
                (_a = meta === null || meta === void 0 ? void 0 : meta.done) === null || _a === void 0 ? void 0 : _a.call(meta, ar);
                return slice.actions.removeFulfilled({ ids: ids, data: response });
            }), (0, operators_1.startWith)(slice.actions.removeStarted({ ids: ids })), (0, operators_1.takeUntil)(action$.pipe((0, operators_1.filter)(slice.actions.cancelRemove.match))), (0, rxjs_1.catchError)(function (err) {
                var _a;
                (_a = meta === null || meta === void 0 ? void 0 : meta.fail) === null || _a === void 0 ? void 0 : _a.call(meta, err);
                return (0, rxjs_1.of)(slice.actions.removeRejected({ ids: ids, error: err }));
            }), (0, operators_1.endWith)(slice.actions.removeEnded({ ids: ids })));
        }));
    };
    var syncAllEpic = function (action$, state$, _a) {
        var get = _a.get;
        return action$.pipe((0, operators_1.filter)(slice.actions.syncAll.match), (0, operators_1.throttleTime)(ajaxThrottleTime), (0, operators_1.mergeMap)(function (_a) {
            var meta = _a.meta;
            var moduleParams = state$.value[name].moduleParams;
            return get(resourceUrl, __assign({ resource_type: resourceType }, moduleParams)).pipe((0, operators_1.map)(function (ar) {
                var _a;
                var response = ar.response;
                (_a = meta === null || meta === void 0 ? void 0 : meta.done) === null || _a === void 0 ? void 0 : _a.call(meta, ar);
                return slice.actions.syncAllFulfilled({ data: response });
            }), (0, operators_1.startWith)(slice.actions.syncAllStarted({})), (0, operators_1.takeUntil)(action$.pipe((0, operators_1.filter)(slice.actions.cancelSyncAll.match))), (0, rxjs_1.catchError)(function (err) {
                var _a;
                (_a = meta === null || meta === void 0 ? void 0 : meta.fail) === null || _a === void 0 ? void 0 : _a.call(meta, { error: err });
                return (0, rxjs_1.of)(slice.actions.syncAllRejected({ error: err }));
            }), (0, operators_1.endWith)(slice.actions.syncAllEnded({})));
        }));
    };
    var _epics = {
        syncEpic: syncEpic,
        syncItemEpic: syncItemEpic,
        createItemEpic: createItemEpic,
        updateItemEpic: updateItemEpic,
        updateEpic: updateEpic,
        removeEpic: removeEpic,
        syncAllEpic: syncAllEpic,
    };
    if (epics) {
        if (typeof epics === 'function') {
            _epics = epics(_epics);
        }
        else {
            _epics = __assign(__assign({}, _epics), epics);
        }
    }
    var epicList = Object.keys(_epics).map(function (k) { return _epics[k]; });
    var epic = redux_observable_1.combineEpics.apply(void 0, epicList);
    return {
        slice: slice,
        epic: epic,
        name: name,
        actions: slice.actions,
        reducer: slice.reducer,
        selectors: _selectors,
    };
};
exports.createModule = createModule;
